#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const commander_1 = require("commander");
const setup_1 = require("./setup");
const exec_1 = __importDefault(require("@simplyhexagonal/exec"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const path_1 = __importDefault(require("path"));
var setup_2 = require("./setup");
Object.defineProperty(exports, "create", { enumerable: true, get: function () { return setup_2.setup; } });
main();
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        commander_1.program.name('setup').addHelpText('after', `
        
        Use this script to setup the project.`);
        commander_1.program
            .option('--directory <path>', 'The path of the directory where the package will be created')
            .option('--package-name <name>', 'The name of the package')
            .option('--description Creates typescript npm package', 'The description of the package')
            .option('--repository-url <url>', 'The url of the repository');
        commander_1.program.parse(process.argv);
        const { directory = 'typescript-npm-package', packageName, description = '', repositoryUrl = '', } = commander_1.program.opts();
        if (!packageName)
            throw new Error('Please provide a package name by using --package-name option');
        if (yield fs_extra_1.default.pathExists(directory)) {
            throw new Error(`The directory ${directory} already exists`);
        }
        const { execPromise: gitInitExecPromise } = (0, exec_1.default)(`git clone https://github.com/FreePhoenix888/typescript-npm-package-template.git ${directory}`);
        const gitInitResult = yield gitInitExecPromise;
        if (gitInitResult.exitCode !== 0) {
            throw new Error(gitInitResult.stderrOutput);
        }
        console.log(gitInitResult.stdoutOutput);
        yield fs_extra_1.default.remove(path_1.default.join(directory, '.git'));
        yield (0, setup_1.setup)({ packageName, description, repositoryUrl, path: directory });
    });
}
